; #########################################################################

  ; --------------------------------------------------
  ; This procedure was written by Raymond Filiatreault
  ; --------------------------------------------------

    .386
    .model flat, stdcall  ; 32 bit memory model
    option casemap :none  ; case sensitive

      include \masm32\include\Mix.inc

    .code

; #########################################################################

MixFromInt proc public wInt:DWORD
        
    ; -------------------------------------------------------------
    ; Converts an integer to the Mixed Integer format.
    ;
    ; wInt: A signed integer with an absolute value =< 7FFFh (32767).
    ; 
    ; EXAMPLE:
    ;
    ;       invoke MixFromInt, var
    ;
    ; The result is returned in eax. If the absolute value of the
    ; parameter is greater than 7FFFh, the returned result would be
    ; 80000000h (i.e. -0)
    ;
    ; -------------------------------------------------------------

    mov eax,wInt
    or  eax,eax
    jns @F
    neg eax
  @@:
    cmp eax,7FFFh
    jbe @F
    mov eax,ERROR
    ret
  @@:
    mov eax,wInt
    shl eax,16
    ret
    
MixFromInt endp

; #########################################################################

end
