; #########################################################################

  ; --------------------------------------------------
  ; This procedure was written by Raymond Filiatreault
  ; --------------------------------------------------

    .386
    .model flat, stdcall  ; 32 bit memory model
    option casemap :none  ; case sensitive

      include \masm32\include\Mix.inc

      includelib \masm32\lib\Mix.lib

    ERROR   EQU 80000000h

    .code

; #########################################################################

MixSqrt proc public MInt:DWORD
        
    ; -------------------------------------------------------------
    ; Extracts the sqrare root of a positive Mixed Integer DWORD
    ;
    ; eax, ecx, edx used
    ;
    ; MInt:    A Mixed Integer DWORD.
    ;
    ; EXAMPLE:
    ;
    ;       invoke MixSqrt, var1 
    ;
    ; The result is returned in eax in a Mixed Integer format. If the
    ; value of the parameter is negative, the returned value would be
    ; 80000000h (i.e. -0).
    ;
    ; If the parameter is 80000000h, it is returned unchanged.
    ;
    ; -------------------------------------------------------------

    mov eax,MInt
    or  eax,eax
    jnz @F
    ret                 ;the square root of 0 is 0

  @@:
    jns @F
    mov eax,ERROR
    ret                 ;the square root of a negative number is an error
                        ;the error code would also show as being negative

  @@:
    mov edx,eax
    shr edx,16
    shl eax,16

    invoke sqrt64,edx,eax
    
    ret
    
MixSqrt endp

; #########################################################################

end

